Index: drivers/video/radeonfb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/radeonfb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/radeonfb.c	22 Jul 2004 19:50:22 -0000	1.1
+++ drivers/video/radeonfb.c	4 Aug 2004 01:29:58 -0000	1.2
@@ -1511,42 +1605,363 @@
 		b = (tmp & FP_CRTC_V_DISP_MASK) >> FP_CRTC_V_DISP_SHIFT;
 		rinfo->vblank = a - b /* + 24 */ ;
 
-		tmp = INREG(FP_V_SYNC_STRT_WID);
-		rinfo->vOver_plus = (unsigned short) (tmp & FP_V_SYNC_STRT_MASK)
-					- b + 1;
-		rinfo->vSync_width = (unsigned short) ((tmp & FP_V_SYNC_WID_MASK) >>
-					FP_V_SYNC_WID_SHIFT);
+		tmp = INREG(FP_V_SYNC_STRT_WID);
+		rinfo->vOver_plus = (unsigned short) (tmp & FP_V_SYNC_STRT_MASK)
+					- b + 1;
+		rinfo->vSync_width = (unsigned short) ((tmp & FP_V_SYNC_WID_MASK) >>
+					FP_V_SYNC_WID_SHIFT);
+
+		/* XXX */
+		/* We should calculate the pixclock as well here... --BenH.
+		 */
+
+		return 1;
+	}
+
+	return 1;
+}
+
+static int radeonfb_pci_register (struct pci_dev *pdev,
+				  const struct pci_device_id *ent)
+{
+	struct radeonfb_info *rinfo;
+	struct radeon_chip_info *rci = &radeon_chip_info[ent->driver_data];
+	u32 tmp;
+	int i, j;
+
+	RTRACE("radeonfb_pci_register BEGIN\n");
+
+	rinfo = kmalloc (sizeof (struct radeonfb_info), GFP_KERNEL);
+	if (!rinfo) {
+		printk ("radeonfb: could not allocate memory\n");
+		return -ENODEV;
+	}
+
+	memset (rinfo, 0, sizeof (struct radeonfb_info));
+
+	rinfo->pdev = pdev;
+	strncpy(rinfo->name, rci->name, 16);
+	rinfo->arch = rci->arch;
+
+	/* enable device */
+	{
+		int err;
+
+		if ((err = pci_enable_device(pdev))) {
+			printk("radeonfb: cannot enable device\n");
+			kfree (rinfo);
+			return -ENODEV;
+		}
+	}
+
+	/* set base addrs */
+	rinfo->fb_base_phys = pci_resource_start (pdev, 0);
+	rinfo->mmio_base_phys = pci_resource_start (pdev, 2);
+
+	/* request the mem regions */
+	if (!request_mem_region (rinfo->fb_base_phys,
+				 pci_resource_len(pdev, 0), "radeonfb")) {
+		printk ("radeonfb: cannot reserve FB region\n");
+		kfree (rinfo);
+		return -ENODEV;
+	}
+
+	if (!request_mem_region (rinfo->mmio_base_phys,
+				 pci_resource_len(pdev, 2), "radeonfb")) {
+		printk ("radeonfb: cannot reserve MMIO region\n");
+		release_mem_region (rinfo->fb_base_phys,
+				    pci_resource_len(pdev, 0));
+		kfree (rinfo);
+		return -ENODEV;
+	}
+
+	/* map the regions */
+	rinfo->mmio_base = (unsigned long) ioremap (rinfo->mmio_base_phys,
+				    		    RADEON_REGSIZE);
+	if (!rinfo->mmio_base) {
+		printk ("radeonfb: cannot map MMIO\n");
+		release_mem_region (rinfo->mmio_base_phys,
+				    pci_resource_len(pdev, 2));
+		release_mem_region (rinfo->fb_base_phys,
+				    pci_resource_len(pdev, 0));
+		kfree (rinfo);
+		return -ENODEV;
+	}
+
+	rinfo->chipset = pdev->device;
+
+	switch (rinfo->arch) {
+		case RADEON_R100:
+			rinfo->hasCRTC2 = 0;
+			break;
+		default:
+			/* all the rest have it */
+			rinfo->hasCRTC2 = 1;
+			break;
+	}
+
+	if (mirror)
+		printk("radeonfb: mirroring display to CRT\n");
+
+	/* framebuffer size */
+	tmp = INREG(CONFIG_MEMSIZE);
+
+	/* mem size is bits [28:0], mask off the rest */
+	rinfo->video_ram = tmp & CONFIG_MEMSIZE_MASK;
+
+	/* ram type */
+	tmp = INREG(MEM_SDRAM_MODE_REG);
+	switch ((MEM_CFG_TYPE & tmp) >> 30) {
+		case 0:
+			/* SDR SGRAM (2:1) */
+			strcpy(rinfo->ram_type, "SDR SGRAM");
+			rinfo->ram.ml = 4;
+			rinfo->ram.mb = 4;
+			rinfo->ram.trcd = 1;
+			rinfo->ram.trp = 2;
+			rinfo->ram.twr = 1;
+			rinfo->ram.cl = 2;
+			rinfo->ram.loop_latency = 16;
+			rinfo->ram.rloop = 16;
+	
+			break;
+		case 1:
+			/* DDR SGRAM */
+			strcpy(rinfo->ram_type, "DDR SGRAM");
+			rinfo->ram.ml = 4;
+			rinfo->ram.mb = 4;
+			rinfo->ram.trcd = 3;
+			rinfo->ram.trp = 3;
+			rinfo->ram.twr = 2;
+			rinfo->ram.cl = 3;
+			rinfo->ram.tr2w = 1;
+			rinfo->ram.loop_latency = 16;
+			rinfo->ram.rloop = 16;
+
+			break;
+		default:
+			/* 64-bit SDR SGRAM */
+			strcpy(rinfo->ram_type, "SDR SGRAM 64");
+			rinfo->ram.ml = 4;
+			rinfo->ram.mb = 8;
+			rinfo->ram.trcd = 3;
+			rinfo->ram.trp = 3;
+			rinfo->ram.twr = 1;
+			rinfo->ram.cl = 3;
+			rinfo->ram.tr2w = 1;
+			rinfo->ram.loop_latency = 17;
+			rinfo->ram.rloop = 17;
+
+			break;
+	}
+
+	rinfo->bios_seg = radeon_find_rom(rinfo);
+	radeon_get_pllinfo(rinfo, rinfo->bios_seg);
+
+	/*
+	 * Hack to get around some busted production M6's
+	 * reporting no ram
+	 */
+	if (rinfo->video_ram == 0) {
+		switch (pdev->device) {
+			case PCI_DEVICE_ID_ATI_RADEON_LY:
+			case PCI_DEVICE_ID_ATI_RADEON_LZ:
+				rinfo->video_ram = 8192 * 1024;
+				break;
+			default:
+				break;
+		}
+	}
+
+
+	RTRACE("radeonfb: probed %s %dk videoram\n", (rinfo->ram_type), (rinfo->video_ram/1024));
+
+	RTRACE("BIOS 4 scratch = %x\n", INREG(RADEON_BIOS_4_SCRATCH));
+	RTRACE("FP_GEN_CNTL: %x, FP2_GEN_CNTL: %x\n",
+		INREG(FP_GEN_CNTL), INREG(FP2_GEN_CNTL));
+	RTRACE("TMDS_TRANSMITTER_CNTL: %x, TMDS_CNTL: %x, LVDS_GEN_CNTL: %x\n",
+		INREG(TMDS_TRANSMITTER_CNTL), INREG(TMDS_CNTL), INREG(LVDS_GEN_CNTL));
+	RTRACE("DAC_CNTL: %x, DAC_CNTL2: %x, CRTC_GEN_CNTL: %x\n",
+		INREG(DAC_CNTL), INREG(DAC_CNTL2), INREG(CRTC_GEN_CNTL));
+
+
+#if !defined(__powerpc__)
+	radeon_get_moninfo(rinfo);
+#else
+	switch (rinfo->arch) {
+		case RADEON_M6:
+		case RADEON_M7:
+		case RADEON_M9:
+			/* If forced to no-LCD, we shut down the backlight */
+			if (force_nolcd) {
+#ifdef CONFIG_PMAC_BACKLIGHT
+				radeon_set_backlight_enable(0, BACKLIGHT_OFF, rinfo);
+#endif
+			} else {
+				rinfo->dviDisp_type = MT_LCD;
+				break;
+			}
+			/* Fall through */
+		default:
+			radeon_get_moninfo(rinfo);
+			break;
+	}
+#endif
+
+	radeon_get_EDID(rinfo);
+
+	if ((rinfo->dviDisp_type == MT_DFP) || (rinfo->dviDisp_type == MT_LCD) ||
+	    (rinfo->crtDisp_type == MT_DFP)) {
+		if (!radeon_get_dfpinfo(rinfo)) {
+			iounmap ((void*)rinfo->mmio_base);
+			release_mem_region (rinfo->mmio_base_phys,
+					    pci_resource_len(pdev, 2));
+			release_mem_region (rinfo->fb_base_phys,
+					    pci_resource_len(pdev, 0));
+			kfree (rinfo);
+			return -ENODEV;
+		}
+	}
+
+	rinfo->fb_base = (unsigned long) ioremap (rinfo->fb_base_phys,
+				  		  rinfo->video_ram);
+	if (!rinfo->fb_base) {
+		printk ("radeonfb: cannot map FB\n");
+		iounmap ((void*)rinfo->mmio_base);
+		release_mem_region (rinfo->mmio_base_phys,
+				    pci_resource_len(pdev, 2));
+		release_mem_region (rinfo->fb_base_phys,
+				    pci_resource_len(pdev, 0));
+		kfree (rinfo);
+		return -ENODEV;
+	}
+
+	/* currcon not yet configured, will be set by first switch */
+	rinfo->currcon = -1;
+
+	/* On PPC, the firmware sets up a memory mapping that tends
+	 * to cause lockups when enabling the engine. We reconfigure
+	 * the card internal memory mappings properly
+	 */
+#ifdef CONFIG_ALL_PPC
+	radeon_fixup_apertures(rinfo);
+#else	
+	rinfo->fb_local_base = INREG(MC_FB_LOCATION) << 16;
+#endif /* CONFIG_ALL_PPC */
+
+	/* save current mode regs before we switch into the new one
+	 * so we can restore this upon __exit
+	 */
+	radeon_save_state (rinfo, &rinfo->init_state);
+
+	/* init palette */
+	for (i=0; i<16; i++) {
+		j = color_table[i];
+		rinfo->palette[i].red = default_red[j];
+		rinfo->palette[i].green = default_grn[j];
+		rinfo->palette[i].blue = default_blu[j];
+	}
+
+	pci_set_drvdata(pdev, rinfo);
+	rinfo->next = board_list;
+	board_list = rinfo;
+
+	/* set all the vital stuff */
+	radeon_set_fbinfo (rinfo);
+
+	if (register_framebuffer ((struct fb_info *) rinfo) < 0) {
+		printk ("radeonfb: could not register framebuffer\n");
+		iounmap ((void*)rinfo->fb_base);
+		iounmap ((void*)rinfo->mmio_base);
+		release_mem_region (rinfo->mmio_base_phys,
+				    pci_resource_len(pdev, 2));
+		release_mem_region (rinfo->fb_base_phys,
+				    pci_resource_len(pdev, 0));
+		kfree (rinfo);
+		return -ENODEV;
+	}
+
+#ifdef CONFIG_MTRR
+	rinfo->mtrr_hdl = nomtrr ? -1 : mtrr_add(rinfo->fb_base_phys,
+						 rinfo->video_ram,
+						 MTRR_TYPE_WRCOMB, 1);
+#endif
 
-		return 1;
+
+#ifdef CONFIG_PMAC_BACKLIGHT
+	if (rinfo->dviDisp_type == MT_LCD)
+		register_backlight_controller(&radeon_backlight_controller,
+					      rinfo, "ati");
+#endif
+
+	printk ("radeonfb: ATI Radeon %s %s %d MB\n", rinfo->name, rinfo->ram_type,
+		(rinfo->video_ram/(1024*1024)));
+
+	if (rinfo->hasCRTC2) {
+		printk("radeonfb: DVI port %s monitor connected\n",
+			GET_MON_NAME(rinfo->dviDisp_type));
+		printk("radeonfb: CRT port %s monitor connected\n",
+			GET_MON_NAME(rinfo->crtDisp_type));
+	} else {
+		printk("radeonfb: CRT port %s monitor connected\n",
+			GET_MON_NAME(rinfo->crtDisp_type));
 	}
 
-	return 1;
-}
+#ifdef CONFIG_PMAC_PBOOK
+	if (rinfo->arch == RADEON_M6 || 
+	    rinfo->arch == RADEON_M7 || 
+	    rinfo->arch == RADEON_M9) {
+               /* Find PM registers in config space */
+               rinfo->pm_reg = pci_find_capability(pdev, PCI_CAP_ID_PM);
+
+               /* Enable dynamic PM of chip clocks */
+               radeon_pm_enable_dynamic_mode(rinfo);
+
+               /* Register sleep callbacks */
+               pmu_register_sleep_notifier(&radeon_sleep_notifier);
+               printk("radeonfb: Power Management enabled for Mobility chipsets\n");
+       }
+#endif
 
+	RTRACE("radeonfb_pci_register END\n");
 
-#ifdef CONFIG_ALL_PPC
-static int radeon_read_OF (struct radeonfb_info *rinfo)
-{
-	struct device_node *dp;
-	unsigned int *xtal;
+	return 0;
+}
 
-	dp = pci_device_to_OF_node(rinfo->pdev);
 
-	xtal = (unsigned int *) get_property(dp, "ATY,RefCLK", 0);
 
-	rinfo->pll.ref_clk = *xtal / 10;
+static void __devexit radeonfb_pci_unregister (struct pci_dev *pdev)
+{
+        struct radeonfb_info *rinfo = pci_get_drvdata(pdev);
+ 
+        if (!rinfo)
+                return;
+ 
+	/* restore original state */
+        radeon_write_mode (rinfo, &rinfo->init_state);
+ 
+#ifdef CONFIG_MTRR
+	if (rinfo->mtrr_hdl >= 0)
+		mtrr_del(rinfo->mtrr_hdl, 0, 0);
+#endif
 
-	if (*xtal)
-		return 1;
-	else
-		return 0;
+        unregister_framebuffer ((struct fb_info *) rinfo);
+                
+        iounmap ((void*)rinfo->mmio_base);
+        iounmap ((void*)rinfo->fb_base);
+ 
+	release_mem_region (rinfo->mmio_base_phys,
+			    pci_resource_len(pdev, 2));
+	release_mem_region (rinfo->fb_base_phys,
+			    pci_resource_len(pdev, 0));
+        
+        kfree (rinfo);
 }
-#endif	
 
 
-static void radeon_engine_init (struct radeonfb_info *rinfo)
+static int radeon_engine_init (struct radeonfb_info *rinfo)
 {
-	u32 temp;
+	unsigned long temp;
 
 	/* disable 3D engine */
 	OUTREG(RB3D_CNTL, 0);
@@ -1554,25 +1969,33 @@
 	radeon_engine_reset ();
 
 	radeon_fifo_wait (1);
-	OUTREG(DSTCACHE_MODE, 0);
+	if (rinfo->arch != RADEON_R300)
+		OUTREG(RB2D_DSTCACHE_MODE, 0);
 
-	/* XXX */
-	rinfo->pitch = ((rinfo->xres * (rinfo->bpp / 8) + 0x3f)) >> 6;
+	radeon_fifo_wait (3);
+	/* We re-read MC_FB_LOCATION from card as it can have been
+	 * modified by XFree drivers (ouch !)
+	 */
+	rinfo->fb_local_base = INREG(MC_FB_LOCATION) << 16;
 
-	radeon_fifo_wait (1);
-	temp = INREG(DEFAULT_PITCH_OFFSET);
-	OUTREG(DEFAULT_PITCH_OFFSET, ((temp & 0xc0000000) | 
-				      (rinfo->pitch << 0x16)));
+	OUTREG(DEFAULT_PITCH_OFFSET, (rinfo->pitch << 0x16) |
+				     (rinfo->fb_local_base >> 10));
+	OUTREG(DST_PITCH_OFFSET, (rinfo->pitch << 0x16) | (rinfo->fb_local_base >> 10));
+	OUTREG(SRC_PITCH_OFFSET, (rinfo->pitch << 0x16) | (rinfo->fb_local_base >> 10));
 
 	radeon_fifo_wait (1);
+#if defined(__BIG_ENDIAN)
+	OUTREGP(DP_DATATYPE, HOST_BIG_ENDIAN_EN, ~HOST_BIG_ENDIAN_EN);
+#else
 	OUTREGP(DP_DATATYPE, 0, ~HOST_BIG_ENDIAN_EN);
-
+#endif
 	radeon_fifo_wait (1);
 	OUTREG(DEFAULT_SC_BOTTOM_RIGHT, (DEFAULT_SC_RIGHT_MAX |
 					 DEFAULT_SC_BOTTOM_MAX));
 
 	temp = radeon_get_dstbpp(rinfo->depth);
 	rinfo->dp_gui_master_cntl = ((temp << 8) | GMC_CLR_CMP_CNTL_DIS);
+
 	radeon_fifo_wait (1);
 	OUTREG(DP_GUI_MASTER_CNTL, (rinfo->dp_gui_master_cntl |
 				    GMC_BRUSH_SOLID_COLOR |
@@ -1596,6 +2019,8 @@
 	OUTREG(DP_WRITE_MSK, 0xffffffff);
 
 	radeon_engine_idle ();
+
+	return 0;
 }
 
 
@@ -1635,66 +2060,35 @@
         disp = &rinfo->disp;
         
         disp->var = radeonfb_default_var;
-#if defined(__powerpc__)
-	if (rinfo->dviDisp_type == MT_LCD) {
-		if (mac_vmode_to_var(VMODE_1152_768_60, CMODE_8, &disp->var))
-			disp->var = radeonfb_default_var;
-	}
-#endif
-
-	rinfo->depth = var_to_depth(&disp->var);
-	rinfo->bpp = disp->var.bits_per_pixel;
 
+	/* We must initialize disp before calling fb_find_mode, as the later
+	 * will cause an implicit call to radeonfb_set_var that could crash
+	 * if disp is NULL
+	 */
         info->disp = disp;
-
-        radeon_set_dispsw (rinfo, disp);
-
-	if (noaccel)
-	        disp->scrollmode = SCROLL_YREDRAW;
-	else
-		disp->scrollmode = 0;
-        
         rinfo->currcon_display = disp;
 
-        if ((radeon_init_disp_var (rinfo)) < 0)
-                return -1;
-        
-        return 0;
-}
-
-
-
-static int radeon_init_disp_var (struct radeonfb_info *rinfo)
-{
 #ifndef MODULE
         if (mode_option)
-                fb_find_mode (&rinfo->disp.var, &rinfo->info, mode_option,
+                fb_find_mode (&disp->var, &rinfo->info, mode_option,
                               NULL, 0, NULL, 8);
         else
 #endif
-#if defined(__powerpc__)
-	if (rinfo->dviDisp_type == MT_LCD) {
-		if (mac_vmode_to_var(VMODE_1152_768_60, CMODE_8, &rinfo->disp.var))
-			rinfo->disp.var = radeonfb_default_var;
-	}
-	else
-#endif
-	if (rinfo->use_default_var)
-		/* We will use the modified default far */
-		rinfo->disp.var = radeonfb_default_var;
-	else
-
-                fb_find_mode (&rinfo->disp.var, &rinfo->info, "640x480-8@60",
+	if (!rinfo->use_default_var)
+                fb_find_mode (&disp->var, &rinfo->info, "640x480-8@60",
                               NULL, 0, NULL, 0);
 
-	if (noaccel)
-		rinfo->disp.var.accel_flags &= ~FB_ACCELF_TEXT;
-	else
-		rinfo->disp.var.accel_flags |= FB_ACCELF_TEXT;
- 
-        return 0;
-}
+	disp->var.accel_flags |= FB_ACCELF_TEXT;
+
+	/* Do we need that below ? ... */
+	rinfo->depth = var_to_depth(&disp->var);
+	rinfo->bpp = disp->var.bits_per_pixel;
 
+	/* Apply that dawn mode ! */
+	radeon_do_set_var(&disp->var, -1, 0, info);
+
+	return 0;
+}
 
 
 static void radeon_set_dispsw (struct radeonfb_info *rinfo, struct display *disp)
@@ -1717,43 +2111,58 @@
         switch (disp->var.bits_per_pixel) {
 #ifdef FBCON_HAS_CFB8
                 case 8:
-                        disp->dispsw = &fbcon_cfb8;
                         disp->visual = FB_VISUAL_PSEUDOCOLOR;
-                        disp->line_length = disp->var.xres_virtual;
+                        disp->dispsw = accel ? &fbcon_radeon8 : &fbcon_cfb8;
+                        if (accel)
+                        	disp->line_length = (disp->var.xres_virtual + 0x3f) & ~0x3f;
+                        else
+                        	disp->line_length = disp->var.xres_virtual;
                         break;
-#endif
+#endif /* FBCON_HAS_CFB8 */
+
 #ifdef FBCON_HAS_CFB16
                 case 16:
-                        disp->dispsw = &fbcon_cfb16;
+                        disp->dispsw = accel ? &fbcon_radeon16 : &fbcon_cfb16;
                         disp->dispsw_data = &rinfo->con_cmap.cfb16;
                         disp->visual = FB_VISUAL_DIRECTCOLOR;
-                        disp->line_length = disp->var.xres_virtual * 2;
+                        if (accel)
+				disp->line_length = (disp->var.xres_virtual * 2 + 0x3f) & ~0x3f;
+			else
+				disp->line_length = disp->var.xres_virtual * 2;
                         break;
-#endif  
-#ifdef FBCON_HAS_CFB32       
+#endif  /* FBCON_HAS_CFB16 */
+
+#ifdef FBCON_HAS_CFB24       
                 case 24:
                         disp->dispsw = &fbcon_cfb24;
                         disp->dispsw_data = &rinfo->con_cmap.cfb24;
                         disp->visual = FB_VISUAL_DIRECTCOLOR;
-                        disp->line_length = disp->var.xres_virtual * 4;
+                        if (accel)
+				disp->line_length = (disp->var.xres_virtual * 3 + 0x3f) & ~0x3f;
+			else
+				disp->line_length = disp->var.xres_virtual * 3;
                         break;
-#endif
+#endif /* FBCON_HAS_CFB24 */
+
 #ifdef FBCON_HAS_CFB32
                 case 32:
-                        disp->dispsw = &fbcon_cfb32;
+                        disp->dispsw = accel ? &fbcon_radeon32 : &fbcon_cfb32;
                         disp->dispsw_data = &rinfo->con_cmap.cfb32;
                         disp->visual = FB_VISUAL_DIRECTCOLOR;
-                        disp->line_length = disp->var.xres_virtual * 4;
+                        if (accel)
+				disp->line_length = (disp->var.xres_virtual * 4 + 0x3f) & ~0x3f;
+			else
+				disp->line_length = disp->var.xres_virtual * 4;
                         break;   
-#endif
+#endif /* FBCON_HAS_CFB32 */
+
                 default:
                         printk ("radeonfb: setting fbcon_dummy renderer\n");
                         disp->dispsw = &fbcon_dummy;
         }
                 
         return;
-}
-                        
+}                        
 
 
 static void do_install_cmap(int con, struct fb_info *info)
@@ -1849,7 +2258,7 @@
         disp = (con < 0) ? rinfo->info.disp : &fb_display[con];
 
         memset (fix, 0, sizeof (struct fb_fix_screeninfo));
-	strcpy (fix->id, rinfo->name);
+	sprintf (fix->id, "ATI Radeon %s", rinfo->name);
         
         fix->smem_start = rinfo->fb_base_phys;
         fix->smem_len = rinfo->video_ram;
@@ -1887,19 +2296,18 @@
 }
 
 
-
-static int radeonfb_set_var (struct fb_var_screeninfo *var, int con,
-                             struct fb_info *info)
+static int radeon_do_set_var (struct fb_var_screeninfo *var, int con,
+                             int real, struct fb_info *info)
 {
         struct radeonfb_info *rinfo = (struct radeonfb_info *) info;
         struct display *disp;
         struct fb_var_screeninfo v;
         int nom, den, accel;
-        unsigned chgvar = 0;
+        unsigned chgvar = 1;
 
         disp = (con < 0) ? rinfo->info.disp : &fb_display[con];
 
-        accel = var->accel_flags & FB_ACCELF_TEXT;
+        accel = (noaccel == 0) && ((var->accel_flags & FB_ACCELF_TEXT) != 0);
 
         if (con >= 0) {
                 chgvar = ((disp->var.xres != var->xres) ||
@@ -1909,9 +2317,12 @@
                           (disp->var.bits_per_pixel != var->bits_per_pixel) ||
                           memcmp (&disp->var.red, &var->red, sizeof (var->red)) ||
                           memcmp (&disp->var.green, &var->green, sizeof (var->green)) ||
-                          memcmp (&disp->var.blue, &var->blue, sizeof (var->blue)));
+                          memcmp (&disp->var.blue, &var->blue, sizeof (var->blue)) ||
+                          var->accel_flags != disp->var.accel_flags);
         }
 
+try_again:
+
         memcpy (&v, var, sizeof (v));
 
         switch (v.bits_per_pixel) {
@@ -1935,7 +2346,10 @@
 #ifdef FBCON_HAS_CFB8
                 case 8:
                         nom = den = 1;
-                        disp->line_length = v.xres_virtual;
+                        if (accel)
+                        	disp->line_length = (v.xres_virtual + 0x3f) & ~0x3f;
+                        else
+                        	disp->line_length = v.xres_virtual;
                         disp->visual = FB_VISUAL_PSEUDOCOLOR; 
                         v.red.offset = v.green.offset = v.blue.offset = 0;
                         v.red.length = v.green.length = v.blue.length = 8;
@@ -1947,7 +2361,10 @@
 		case 15:
 			nom = 2;
 			den = 1;
-			disp->line_length = v.xres_virtual * 2;
+			if (accel)
+                        	disp->line_length = (v.xres_virtual * 2 + 0x3f) & ~0x3f;
+			else
+                        	disp->line_length = v.xres_virtual * 2;
 			disp->visual = FB_VISUAL_DIRECTCOLOR;
 			v.red.offset = 10;
 			v.green.offset = 5;
@@ -1958,7 +2375,10 @@
                 case 16:
                         nom = 2;
                         den = 1;
-                        disp->line_length = v.xres_virtual * 2;
+			if (accel)
+                        	disp->line_length = (v.xres_virtual * 2 + 0x3f) & ~0x3f;
+			else
+                        	disp->line_length = v.xres_virtual * 2;
                         disp->visual = FB_VISUAL_DIRECTCOLOR;
                         v.red.offset = 11;
                         v.green.offset = 5;
@@ -1974,7 +2394,10 @@
                 case 24:
                         nom = 4;
                         den = 1;
-                        disp->line_length = v.xres_virtual * 3;
+			if (accel)
+                        	disp->line_length = (v.xres_virtual * 3 + 0x3f) & ~0x3f;
+			else
+                        	disp->line_length = v.xres_virtual * 3;
                         disp->visual = FB_VISUAL_DIRECTCOLOR;
                         v.red.offset = 16;
                         v.green.offset = 8;
@@ -1987,7 +2410,10 @@
                 case 32:
                         nom = 4;
                         den = 1;
-                        disp->line_length = v.xres_virtual * 4;
+			if (accel)
+                        	disp->line_length = (v.xres_virtual * 4 + 0x3f) & ~0x3f;
+			else
+                        	disp->line_length = v.xres_virtual * 4;
                         disp->visual = FB_VISUAL_DIRECTCOLOR;
                         v.red.offset = 16;
                         v.green.offset = 8;
@@ -2030,28 +2456,47 @@
                 default:
                         return -EINVAL;
         }
+
+        /* Set real accel */
+        if (accel)
+	        v.accel_flags |= FB_ACCELF_TEXT;
+        else
+	        v.accel_flags &= ~FB_ACCELF_TEXT;
         
         memcpy (&disp->var, &v, sizeof (v));
-        
+
+        if (real)
+        	radeon_load_video_mode (rinfo, &v);
+	if (accel && real) {
+		if (radeon_engine_init(rinfo) < 0) {
+                        var->accel_flags &= ~FB_ACCELF_TEXT;
+			goto try_again;
+		}
+	}
+
         if (chgvar) {     
-                radeon_set_dispsw(rinfo, disp);
+	        radeon_set_dispsw(rinfo, disp);
 
-                if (noaccel)
+                if (!accel)
                         disp->scrollmode = SCROLL_YREDRAW;
                 else
                         disp->scrollmode = 0;
                 
-                if (info && info->changevar)
+                if (info && info->changevar && con >= 0)
                         info->changevar(con);
         }
-         
-        radeon_load_video_mode (rinfo, &v);
-                
-        do_install_cmap(con, info);
+
+        if (real)        
+        	do_install_cmap(con, info);
   
         return 0;
 }
 
+static int radeonfb_set_var (struct fb_var_screeninfo *var, int con,
+                             struct fb_info *info)
+{
+	return radeon_do_set_var(var, con, 1, info);
+}
 
 
 static int radeonfb_get_cmap (struct fb_cmap *cmap, int kspc, int con,
@@ -2107,19 +2552,17 @@
                                  struct fb_info *info)
 {
         struct radeonfb_info *rinfo = (struct radeonfb_info *) info;
-        u32 offset, xoffset, yoffset;
-                
-        xoffset = (var->xoffset + 7) & ~7;
-        yoffset = var->yoffset;
-                
-        if ((xoffset + var->xres > var->xres_virtual) || (yoffset+var->yres >
-                var->yres_virtual))
-                return -EINVAL;
+                        
+        if (((var->xoffset + var->xres) > var->xres_virtual)
+            || ((var->yoffset + var->yres) > var->yres_virtual))
+               return -EINVAL;
+                        
+        if (rinfo->asleep)
+                return 0;
+
+        OUTREG(CRTC_OFFSET, ((var->yoffset * var->xres_virtual + var->xoffset)
+                             * var->bits_per_pixel / 8) & ~7);
                 
-        offset = ((yoffset * var->xres + xoffset) * var->bits_per_pixel) >> 6;
-         
-        OUTREG(CRTC_OFFSET, offset);
-        
         return 0;
 }
 
@@ -2127,6 +2570,79 @@
 static int radeonfb_ioctl (struct inode *inode, struct file *file, unsigned int cmd,
                            unsigned long arg, int con, struct fb_info *info)
 {
+        struct radeonfb_info *rinfo = (struct radeonfb_info *) info;
+	unsigned int tmp;
+	u32 value = 0;
+	int rc;
+
+	switch (cmd) {
+		/*
+		 * TODO:  set mirror accordingly for non-Mobility chipsets with 2 CRTC's
+		 */
+		case FBIO_RADEON_SET_MIRROR:
+			switch (rinfo->arch) {
+				case RADEON_M6:
+				case RADEON_M7:
+				case RADEON_M9:
+					break;
+				default:
+					return -EINVAL;
+			}
+
+			rc = get_user(value, (__u32*)arg);
+
+			if (rc)
+				return rc;
+
+			if (value & 0x01) {
+				tmp = INREG(LVDS_GEN_CNTL);
+
+				tmp |= (LVDS_ON | LVDS_BLON);
+			} else {
+				tmp = INREG(LVDS_GEN_CNTL);
+
+				tmp &= ~(LVDS_ON | LVDS_BLON);
+			}
+
+			OUTREG(LVDS_GEN_CNTL, tmp);
+
+			if (value & 0x02) {
+				tmp = INREG(CRTC_EXT_CNTL);
+				tmp |= CRTC_CRT_ON;
+
+				mirror = 1;
+			} else {
+				tmp = INREG(CRTC_EXT_CNTL);
+				tmp &= ~CRTC_CRT_ON;
+
+				mirror = 0;
+			}
+
+			OUTREG(CRTC_EXT_CNTL, tmp);
+
+			return 0;
+
+		case FBIO_RADEON_GET_MIRROR:
+			switch (rinfo->arch) {
+				case RADEON_M6:
+				case RADEON_M7:
+				case RADEON_M9:
+					break;
+				default:
+					return -EINVAL;
+			}
+
+			tmp = INREG(LVDS_GEN_CNTL);
+			if ((LVDS_ON | LVDS_BLON) & tmp)
+				value |= 0x01;
+
+			tmp = INREG(CRTC_EXT_CNTL);
+			if (CRTC_CRT_ON & tmp)
+				value |= 0x02;
+
+			return put_user(value, (__u32*)arg);
+	}
+
 	return -EINVAL;
 }
 
@@ -2134,42 +2650,55 @@
 static int radeonfb_switch (int con, struct fb_info *info)
 {
         struct radeonfb_info *rinfo = (struct radeonfb_info *) info;
-        struct display *disp;
+        struct display *disp, *old_disp;
         struct fb_cmap *cmap;
         int switchmode = 0;
         
         disp = (con < 0) ? rinfo->info.disp : &fb_display[con];
+        old_disp = rinfo->currcon_display;
                 
         if (rinfo->currcon >= 0) {
                 cmap = &(rinfo->currcon_display->cmap);
                 if (cmap->len)
                         fb_get_cmap (cmap, 1, radeon_getcolreg, info);
         }   
-                
-	switchmode = (con != rinfo->currcon);
 
+        if ((old_disp == NULL) || ((disp->var.xres != old_disp->var.xres) ||
+            (disp->var.yres != old_disp->var.yres) ||
+            (disp->var.xres_virtual != old_disp->var.xres_virtual) ||
+            (disp->var.yres_virtual != old_disp->var.yres_virtual) ||
+            (disp->var.bits_per_pixel != old_disp->var.bits_per_pixel) ||
+            memcmp (&disp->var.red, &old_disp->var.red, sizeof (old_disp->var.red)) ||
+            memcmp (&disp->var.green, &old_disp->var.green, sizeof (old_disp->var.green)) ||
+            memcmp (&disp->var.blue, &old_disp->var.blue, sizeof (old_disp->var.blue)) ||
+            old_disp->var.accel_flags != disp->var.accel_flags))
+        	switchmode = 1;                  
+
+	if (rinfo->currcon == -1)
+		switchmode = 1;
+
+try_again:
 	rinfo->currcon = con;
 	rinfo->currcon_display = disp;
 	disp->var.activate = FB_ACTIVATE_NOW;
         
         if (switchmode) {
                 radeonfb_set_var (&disp->var, con, info);
-                radeon_set_dispsw (rinfo, disp);
                 do_install_cmap(con, info);
-        }       
-
-        /* XXX absurd hack for X to restore console */
-        {   
-		OUTREGP(CRTC_EXT_CNTL, rinfo->hack_crtc_ext_cntl,
-			CRTC_HSYNC_DIS | CRTC_VSYNC_DIS | CRTC_DISPLAY_DIS);
-                OUTREG(CRTC_V_SYNC_STRT_WID, rinfo->hack_crtc_v_sync_strt_wid);
+        } else {
+		if (radeon_engine_init(rinfo) < 0) {
+                        disp->var.accel_flags &= ~FB_ACCELF_TEXT;
+                        switchmode = 1;
+			goto try_again;
+		}
         }
 
+        radeon_set_dispsw (rinfo, disp);
+
         return 0;
 }
 
 
-
 static int radeonfb_updatevar (int con, struct fb_info *info)
 {
         int rc;
@@ -2184,8 +2713,12 @@
 {
         struct radeonfb_info *rinfo = (struct radeonfb_info *) info;
         u32 val = INREG(CRTC_EXT_CNTL);
-	u32 val2 = INREG(LVDS_GEN_CNTL);
+	u32 val_lvds = INREG(LVDS_GEN_CNTL);
+	u32 val_dfp = INREG(FP_GEN_CNTL);
 
+	if (rinfo->asleep)
+		return;
+		
 #ifdef CONFIG_PMAC_BACKLIGHT
 	if (rinfo->dviDisp_type == MT_LCD && _machine == _MACH_Pmac) {
 		set_backlight_enable(!blank);
@@ -2196,7 +2729,8 @@
         /* reset it */
         val &= ~(CRTC_DISPLAY_DIS | CRTC_HSYNC_DIS |
                  CRTC_VSYNC_DIS);
-	val2 &= ~(LVDS_DISPLAY_DIS);
+	val_lvds &= ~(LVDS_DISPLAY_DIS);
+	val_dfp |= FP_FPON | FP_TMDS_EN;
 
         switch (blank) {
                 case VESA_NO_BLANKING:
@@ -2210,13 +2744,17 @@
                 case VESA_POWERDOWN:
                         val |= (CRTC_DISPLAY_DIS | CRTC_VSYNC_DIS | 
                                 CRTC_HSYNC_DIS);
-			val2 |= (LVDS_DISPLAY_DIS);
+			val_lvds |= (LVDS_DISPLAY_DIS);
+			val_dfp &= ~(FP_FPON | FP_TMDS_EN);
                         break;
         }
 
 	switch (rinfo->dviDisp_type) {
 		case MT_LCD:
-			OUTREG(LVDS_GEN_CNTL, val2);
+			OUTREG(LVDS_GEN_CNTL, val_lvds);
+			break;
+		case MT_DFP:
+			OUTREG(FP_GEN_CNTL, val_dfp);
 			break;
 		case MT_CRT:
 		default:
@@ -2243,7 +2781,6 @@
 }
 
 
-
 static int radeon_getcolreg (unsigned regno, unsigned *red, unsigned *green,
                              unsigned *blue, unsigned *transp,
                              struct fb_info *info)
@@ -2281,29 +2818,44 @@
 
         /* default */
         pindex = regno;
-        
-	if (rinfo->bpp == 16) {
-		pindex = regno * 8;
 
-		if (rinfo->depth == 16 && regno > 63)
-			return 1;
-		if (rinfo->depth == 15 && regno > 31)
-			return 1;
+        if (!rinfo->asleep) {
+        	u32 dac_cntl2, vclk_cntl;
+        	
+		vclk_cntl = INPLL(VCLK_ECP_CNTL);
+		OUTPLL(VCLK_ECP_CNTL, vclk_cntl & ~PIXCLK_DAC_ALWAYS_ONb);
+
+		/* Make sure we are on first palette */
+		if (rinfo->hasCRTC2) {
+			dac_cntl2 = INREG(DAC_CNTL2);
+			dac_cntl2 &= ~DAC2_PALETTE_ACCESS_CNTL;
+			OUTREG(DAC_CNTL2, dac_cntl2);
+		}
 
-		/* For 565, the green component is mixed one order below */
-		if (rinfo->depth == 16) {
-	                OUTREG(PALETTE_INDEX, pindex>>1);
-       	         	OUTREG(PALETTE_DATA, (rinfo->palette[regno>>1].red << 16) |
-                        	(green << 8) | (rinfo->palette[regno>>1].blue));
-                	green = rinfo->palette[regno<<1].green;
-        	}
-	}
+		if (rinfo->bpp == 16) {
+			pindex = regno * 8;
 
-	if (rinfo->depth != 16 || regno < 32) {
-		OUTREG(PALETTE_INDEX, pindex);
-		OUTREG(PALETTE_DATA, (red << 16) | (green << 8) | blue);
-	}
+			if (rinfo->depth == 16 && regno > 63)
+				return 1;
+			if (rinfo->depth == 15 && regno > 31)
+				return 1;
+
+			/* For 565, the green component is mixed one order below */
+			if (rinfo->depth == 16) {
+		                OUTREG8(PALETTE_INDEX, pindex>>1);
+	       	         	OUTREG(PALETTE_DATA, (rinfo->palette[regno>>1].red << 16) |
+	                        	(green << 8) | (rinfo->palette[regno>>1].blue));
+	                	green = rinfo->palette[regno<<1].green;
+	        	}
+		}
 
+		if (rinfo->depth != 16 || regno < 32) {
+			OUTREG8(PALETTE_INDEX, pindex);
+			OUTREG(PALETTE_DATA, (red << 16) | (green << 8) | blue);
+		}
+
+		OUTPLL(VCLK_ECP_CNTL, vclk_cntl);
+	}
  	if (regno < 16) {
         	switch (rinfo->depth) {
 #ifdef FBCON_HAS_CFB16
@@ -2316,7 +2868,7 @@
 				                       	 	  regno;   
 			        break;
 #endif
-#ifdef FBCON_HAS_CFB24
+#ifdef FBCON_HAS_CFB24   
                         case 24:
                                 rinfo->con_cmap.cfb24[regno] = (regno << 16) | (regno << 8) | regno;
                                 break;
@@ -2330,11 +2882,11 @@
 		        	break;
         		}
 #endif
-		}
+                }
         }
-	return 0;
-}
+        return 0;
 
+}
 
 
 static void radeon_save_state (struct radeonfb_info *rinfo,
